                    INCLUDE  Map.s
						
	AREA    ADCPROC,CODE,READONLY

ADC1Initialize      PROC
	                EXPORT   ADC1Initialize
					LDR      R0,=GPIOACRL
					MOV      R1,#0xF0
					LDRB     R2,[R0]
					AND      R2,R1
					STRB     R2,[R0]
;Analog mode, input mode. CNF0: 00, MODE0: 00.
					LDR      R0,=ADC1CR2
					MOV      R1,#0x01
					STR      R1,[R0]
;Wake up ADC from Power Down mode. ADON: 1.
                    MOV      R1,#0x0C
WaitADCStable       SUB      R1,#0x01
                    CMP      R1,#0x00
					BNE      WaitADCStable
;ADC power-up time.
					MOV      R1,#0x04
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Enable calibration. CAL: 1.
WaitCalibrationCPE  LDR      R2,[R0]
                    AND      R2,R1
					CMP      R2,#0x00
					BNE      WaitCalibrationCPE
;Wait ADC calibration complete.
					LDR      R0,=ADC1DR
					LDRH     R2,[R0]
					LDR      R0,=0x2000004E
					STR      R2,[R0]
;Read calibration value and save to specific variable.
                    LDR      R0,=ADC1SMPR2
					MOV      R2,#0x01
					STR      R2,[R0]
;7.5 cycles. SMP0: 001.
	                BX	     R14
	                ENDP
ADCStart            PROC
	                EXPORT   ADCStart
					PUSH     {R0-R2,R14}
					LDR      R0,=ADC1CR2
					MOV      R1,#0x01
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Enable ADC and to start conversion. ADCON: 1.
                    LDR      R0,=ADC1SR
					MOV      R1,#0x02
WaitConversionCPE   LDR      R2,[R0]
                    AND      R2,R1
					CMP      R2,#0x00
					BEQ      WaitConversionCPE
;Wait ADC conversion complete.
                    LDR      R1,=ADC1DR
					LDRH     R0,[R1]
					LDR      R1,=0x2000004E
					LDRH     R2,[R1]
;Load calibration value
					SUB      R0,R0,R2
					BL       ADCResultCOV
					POP      {R0-R2,R14}
	                BX       R14
	                ENDP
ADCResultCOV        PROC
	                PUSH     {R1-R4}
					MOVW     R1,#0x80E8
					MUL      R0,R1,R0
					MOVW     R1,#0x0FFF
					UDIV     R0,R0,R1
;Get external voltage value: xxxx.x mV.
					LDR      R1,=0x20000040
					MOVW     R2,#0x2710
					UDIV     R2,R0,R2
					ADD      R3,R2,#0x30
					STRB     R3,[R1]
;
					MOVW     R3,#0x3E8
					UDIV     R3,R0,R3
					MOV      R4,#0x0A
					MUL      R2,R4,R2
					SUB      R3,R3,R2
					ADD      R4,R3,#0x30
					STRB     R4,[R1,#0x01]
;
                    ADD      R2,R3
                    MOV      R3,#0x64
					UDIV     R3,R0,R3
					MOV      R4,#0x0A
					MUL      R2,R4,R2
					SUB      R3,R3,R2
					ADD      R4,R3,#0x30
					STRB     R4,[R1,#0x02]
;
                    ADD      R2,R3
					MOV      R3,#0x0A
					UDIV     R3,R0,R3
					MOV      R4,#0x0A
					MUL      R2,R4,R2
					SUB      R3,R3,R2
					ADD      R4,R3,#0x30
					STRB     R4,[R1,#0x03]
;
                    ADD      R2,R3
                    MOV      R3,#0x0A
                    MUL      R2,R3,R2
                    SUB      R3,R0,R2
                    ADD      R3,R3,#0x30
                    STRB     R4,[R1,#0x05]		
					POP      {R1-R4}
					BX       R14
	                ENDP
					END