                    INCLUDE  Map.s
						
	AREA    ADCPROC,CODE,READONLY

ADC1Initialize      PROC
	                EXPORT   ADC1Initialize
					LDR      R0,=GPIOACRL
					LDR      R1,=0xFFFFFFF0
					LDR      R2,[R0]
					AND      R2,R1
					STR      R2,[R0]
;Analog mode, input mode. CNF0: 00, MODE0: 00.
					LDR      R0,=ADC1CR2
					MOV      R1,#0x01
					STR      R1,[R0]
;Wake up ADC from Power Down mode. ADON: 1.
                    MOV      R1,#0x0C
WaitADCStable       SUB      R1,#0x01
                    CMP      R1,#0x00
					BNE      WaitADCStable
;ADC power-up time.
					MOV      R1,#0x04
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Enable calibration. CAL: 1.
WaitCalibrationCPE  LDR      R2,[R0]
                    AND      R2,R1
					CMP      R2,#0x00
					BNE      WaitCalibrationCPE
;Wait ADC calibration complete.
					LDRH     R2,[R0,#0x44]  ;ADC1DR
					LDR      R1,=0x2000004E
					STR      R2,[R1]
;Read calibration value and save to specific variable.
					LDR      R1,=0x00800000
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Temperature sensor and Vrefint channel enable.
					MOV      R2,#0x03
					STR      R2,[R0,#0x08]  ;ADC1SMPR2
;28.5 cycles. SMP0: 011.
					LDR      R2,=0x00E00000
					STR      R2,[R0,#0x04]  ;ADC1SMPR1
;239.5 cycles. SMP17: 001.
	                BX	     R14
	                ENDP
ADCStart            PROC
	                EXPORT   ADCStart
					PUSH     {R0-R3,R14}
					LDR      R0,=ADC1CR2
					MOV      R1,#0x00
					STR      R1,[R0,#0x2C]  ;ADC1SQR3
;1st conversion in regular sequence is channel0. SQ1: 00000
					MOV      R1,#0x01
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Enable ADC and to start conversion. ADCON: 1.
;External input, channal0.
					MOV      R1,#0x02
WaitConversionCPE1  LDR      R2,[R0,#-0x08]  ;ADC1SR
                    AND      R2,R1
					CMP      R2,#0x00
					BEQ      WaitConversionCPE1
;Wait ADC conversion complete.
                    ADD      R1,R0,#0x44
					LDRH     R0,[R1]  ;ADC1DR
;Read external input result.
					MOV      R2,#0x11
					STR      R2,[R1,#-0x18]  ;ADC1SQR3
;1st conversion in regular sequence is channel17. SQ1: 10001
					MOV      R2,#0x01
					LDR      R3,[R1,#-0x44]  ;ADC1CR2
					ORR      R3,R2
					STR      R3,[R1,#-0x44]  ;ADC1CR2
;Enable ADC and to start conversion. ADCON: 1.
;Internal reference voltage input, channal7.
					MOV      R2,#0x02
WaitConversionCPE2  LDR      R3,[R1,#-0x4C]  ;ADC1SR
                    AND      R3,R2
					CMP      R3,#0x00
					BEQ      WaitConversionCPE2
;Wait ADC calibration complete.
                    LDR      R2,=ADC1DR
					LDRH     R1,[R2]
;Read internal reference voltage input result.
					LDR      R2,=0x2000004E
					LDRH     R3,[R2]
;Load calibration value
                    CMP      R0,R3
					ITE      HI
					SUBHI    R0,R0,R3
					MOVLS    R0,#0x00
					SUB      R1,R1,R3
					BL       Filtering
					BL       ADCResultCOV
					POP      {R0-R3,R15}
	                ENDP
ADCResultCOV        PROC
	                PUSH     {R0-R4,R14}
					LDR      R1,=0x20000040
					MOVW     R2,#0x2710
					UDIV     R2,R0,R2
					ADD      R3,R2,#0x30
					STRB     R3,[R1]
;Ten-thousand digit output.
					MOVW     R3,#0x3E8
					UDIV     R3,R0,R3
					MOV      R4,#0x0A
					MUL      R2,R4,R2
					SUB      R3,R3,R2
					ADD      R4,R3,#0x30
					STRB     R4,[R1,#0x01]
;Thousands digit output.
                    ADD      R2,R3
                    MOV      R3,#0x64
					UDIV     R3,R0,R3
					MOV      R4,#0x0A
					MUL      R2,R4,R2
					SUB      R3,R3,R2
					ADD      R4,R3,#0x30
					STRB     R4,[R1,#0x02]
;Hundreds digit output.
                    ADD      R2,R3
					MOV      R3,#0x0A
					UDIV     R3,R0,R3
					MOV      R4,#0x0A
					MUL      R2,R4,R2
					SUB      R3,R3,R2
					ADD      R4,R3,#0x30
					STRB     R4,[R1,#0x03]
;Tens digit output.
                    ADD      R2,R3
                    MOV      R3,#0x0A
                    MUL      R2,R3,R2
                    SUB      R3,R0,R2
                    ADD      R4,R3,#0x30
                    STRB     R4,[R1,#0x05]
;Unit digit output.					
					POP      {R0-R4,R15}
	                ENDP
Filtering           PROC
	                PUSH     {R1-R2,R14}
					LDR       R2,=0x0001DC90
					MUL       R0,R2,R0
					UDIV      R0,R0,R1
;Get external voltage value.
					LDR      R1,=0x20000052
					LDR      R2,[R1]
;Load last average voltage value.
                    MOV      R1,#0x01
                    MUL      R0,R1,R0
					MOV      R1,#0x0F
					MUL      R1,R2,R1
					ADD      R0,R1
                    MOV      R1,#0x10
       				UDIV     R0,R0,R1
;Get current average voltage value.
					LDR      R1,=0x20000052
					STR      R0,[R1]
;Save current average voltage value.
                    MOV      R1,#0x0A
					UDIV     R2,R0,R1
					MUL      R1,R2,R1
					SUB      R1,R0,R1
					CMP      R1,#0x05
					ITE      CS
				    ADDCS    R0,R2,#0x01
					MOVCC    R0,R2
					POP      {R1-R2,R15}
	                ENDP
					ALIGN
					END