                    INCLUDE  Map.s

	AREA    InitializePROC,CODE,READONLY
		
__main              PROC
                    EXPORT   __main
					IMPORT   SysTickInitialize
					IMPORT   IOPortCInitialize
					IMPORT   USART1Initialize
					IMPORT   LoadDataToRAM
					IMPORT   ADC1Initialize
					IMPORT   ShowStartMessage
					BL       RCCInitialize
					BL       LoadDataToRAM
					BL       USART1Initialize
					BL       IOPortCInitialize
					BL       ADC1Initialize
					BL       SleepModelCFG
					BL       ShowStartMessage
					BL       SysTickInitialize
					B    .
					ENDP
RCCInitialize       PROC
					LDR      R0,=RCCCFGR
					LDRB     R1,[R0,#0x02]
					;ORR      R1,#0x1D ;HCLK: 72MHz
					ORR       R1,#0x21 ;HCLK: 112.896MHz
					;ORR      R1,#0x35 ;HCLK: 120MHz
					STRB     R1,[R0,#0x02]
;PLL input clock x 9, HSE oscillator clock selected as PLL input clock. 
;PLLMUL: 0111, PLLSRC: 1.
                    LDRB     R1,[R0,#0x01]
					;ORR      R1,#0x84  ;HCLK: 72MHz
					ORR      R1,#0xC4  ;HCLK: 120MHz or 112.896MHz
					STRB     R1,[R0,#0x01]
;HCLK divided by 2, PCLK2 divided by 6. PPRE1: 100, ADCPRE: 10.
                    LDR      R0,=FLASHACR   
					LDR      R1,[R0]
					ORR      R1,#0x02
					STR      R1,[R0]
;Two wait states. LATENCY: 010
                    LDR      R0,=RCCCR
					LDRB     R1,[R0,#0x02]
					ORR      R1,#0x01
					STRB     R1,[R0,#0x02]
WaitHSEReady        LDRB     R1,[R0,#0x02]
					AND      R1,#0x02
					CMP      R1,#0x02
					BNE      WaitHSEReady
					LDRB     R1,[R0,#0x03]
					ORR      R1,#0x01
					STRB     R1,[R0,#0x03]
WaitPLLReady        LDRB     R1,[R0,#0x03]
                    AND      R1,#0x02
					CMP      R1,#0x02
                    BNE      WaitPLLReady
;HSE Oscillator ON,PLL ON. HSEON: 1, PLLON: 1.
					LDRB     R1,[R0,#0x04]  ;RCCCFGR
					ORR      R1,#0x02
					STRB     R1,[R0,#0x04]  ;RCCCFGR
WaitClockSwitch		LDRB     R1,[R0,#0x04]  ;RCCCFGR
					NOP
					AND      R1,#0x0C
					CMP      R1,#0x08
					BNE      WaitClockSwitch
;PLL selected as system clock. SW: 10.
                    LDRB     R1,[R0]
					AND      R1,#0xFE
					STRB     R1,[R0]
;Internal 8 MHz RC oscillator OFF. HSEON: 0.
					LDRB     R1,[R0,#0x18]  ;RCCAPB2ENR
					ORR      R1,#0x15
					STRB     R1,[R0,#0x18]  ;RCCAPB2ENR
;IO port A, C clock enable, alternate function IO clock enable.
;IOPAEN: 1, IOPCEN: 1, AFIOEN: 1.
					LDRB     R1,[R0,#0x19]  ;RCCAPB2ENR with 1-byte offset
					ORR      R1,#0x02
					STRB     R1,[R0,#0x19]  ;RCCAPB2ENR with 1-byte offset
;ADC1 interface clock enable. ADC1EN: 1.
					LDRB     R1,[R0,#0x19]  ;RCCAPB2ENR with 1-byte offset
					ORR      R1,#0x40
					STRB     R1,[R0,#0x19]  ;RCCAPB2ENR with 1-byte offset
;USART1 clock enable. USART1EN: 1.
                    BX       R14
					ENDP
SleepModelCFG       PROC
	                LDR      R0,=SCBSCR
					LDRB     R1,[R0]
					ORR      R1,#0x02
					STRB     R1,[R0]
;Enable sleep, on return from an interrupt service routine.
;SLEEPONEXIT: 1.
					BX       R14
					ENDP
					ALIGN
					END