StackSize           EQU      0x00000100
	AREA    STACK,NOINIT,READWRITE,ALIGN=3
StackMen            SPACE    StackSize
_initial_sp

HeapSize            EQU      0X00000100
	AREA    HEAP,NOINIT,READWRITE,ALIGN=3
_heap_base
HeapMen             SPACE    HeapSize
_heap_limit

                    PRESERVE8
					THUMB
;Vector Table Mapped to Address 0 at Reset
	AREA    RESET,CODE,READONLY
		            EXPORT   Vectors
Vectors
                    DCD      _initial_sp             
					DCD      Reset_Handler          
					DCD      NMIHandler          
					DCD      HardFaultHandler   
					DCD      MemManageHandler  
					DCD      BusFaultHandler 
					DCD      UsageFaultHandler 
					DCD      0
					DCD      0
					DCD      0
					DCD      0
					DCD      SVCALL
					DCD      DebugMonitor
					DCD      0
					DCD      PendSV
					DCD      SysTickHandler
					DCD      WWDGIRQHandler
					DCD      PVDIRQHandler
					DCD      TAMPERIRQHandler
					DCD      RTCIRQHandler
					DCD      FLASHIRQHandler
					DCD      RCCIRQHandler
					DCD      EXTI0IRQHandler
					DCD      EXTI1IRQHandler
					DCD      EXTI2IRQHandler
					DCD      EXTI3IRQHandler
					DCD      EXTI4IRQHandler
					DCD      DMA1Channel1IRQHandler
					DCD      DMA1Channel2IRQHandler
					DCD      DMA1Channel3IRQHandler
					DCD      DMA1Channel4IRQHandler
					DCD      DMA1Channel5IRQHandler
					DCD      DMA1Channel6IRQHandler
					DCD      DMA1Channel7IRQHandler
					DCD      ADCIRQHandler
EndVectors

	AREA    |.text| ,CODE,READONLY
		
		            ENTRY
Reset_Handler       PROC 
                    EXPORT   Reset_Handler           [WEAK]
					IMPORT   __main
					LDR      R0,=__main
					BX       R0
					ENDP
;Dummy Exception Handlers (infinite loops which can be modified)
NMIHandler          PROC     
	                EXPORT   NMIHandler             [WEAK]
					B    .
					ENDP
HardFaultHandler    PROC     
                    EXPORT   HardFaultHandler       [WEAK]
                    B    .
                    ENDP
MemManageHandler  	PROC  
                    EXPORT   MemManageHandler       [WEAK]
                    B    .
                    ENDP				
BusFaultHandler     PROC 
                    EXPORT   BusFaultHandler        [WEAK]
                    B    .
                    ENDP
UsageFaultHandler   PROC 
                    EXPORT   UsageFaultHandler      [WEAK]
                    B    .
                    ENDP
SVCALL              PROC 
                    EXPORT   SVCALL                 [WEAK]
                    B    .
                    ENDP
DebugMonitor        PROC 
                    EXPORT   DebugMonitor           [WEAK]
                    B    .
                    ENDP
PendSV              PROC 
                    EXPORT   PendSV                 [WEAK]
                    B    .
                    ENDP
SysTickHandler      PROC 
                    EXPORT   SysTickHandler         [WEAK]
                    B    .
                    ENDP
;External interrupts
Default_Handler     PROC 
                    EXPORT   WWDGIRQHandler         [WEAK]
                    EXPORT   PVDIRQHandler          [WEAK]
                    EXPORT   TAMPERIRQHandler       [WEAK]
                    EXPORT   RTCIRQHandler          [WEAK]
                    EXPORT   FLASHIRQHandler        [WEAK]
	                EXPORT   RCCIRQHandler          [WEAK]
	                EXPORT   EXTI0IRQHandler        [WEAK]
	                EXPORT   EXTI1IRQHandler        [WEAK]
	                EXPORT   EXTI2IRQHandler        [WEAK]
	                EXPORT   EXTI3IRQHandler        [WEAK]
	                EXPORT   EXTI4IRQHandler        [WEAK]
	                EXPORT   DMA1Channel1IRQHandler [WEAK]
	                EXPORT   DMA1Channel2IRQHandler [WEAK]
	                EXPORT   DMA1Channel3IRQHandler [WEAK]
	                EXPORT   DMA1Channel4IRQHandler [WEAK]
	                EXPORT   DMA1Channel5IRQHandler [WEAK]
	                EXPORT   DMA1Channel6IRQHandler [WEAK]
	                EXPORT   DMA1Channel7IRQHandler [WEAK]
	                EXPORT   ADCIRQHandler          [WEAK]
WWDGIRQHandler
PVDIRQHandler
TAMPERIRQHandler
RTCIRQHandler
FLASHIRQHandler
RCCIRQHandler
EXTI0IRQHandler
EXTI1IRQHandler
EXTI2IRQHandler
EXTI3IRQHandler
EXTI4IRQHandler
DMA1Channel1IRQHandler
DMA1Channel2IRQHandler
DMA1Channel3IRQHandler
DMA1Channel4IRQHandler
DMA1Channel5IRQHandler
DMA1Channel6IRQHandler
DMA1Channel7IRQHandler
ADCIRQHandler
					B    .
					ENDP
					LDR      R0,=HeapMen
                    ALIGN
					END