                    INCLUDE  Map.s
						
	AREA    ISRPROC,CODE,READONLY

NVICConfiguration   PROC
	                EXPORT   NVICConfiguration
	                LDR      R0,=SCBAIRCR
					MOVW     R1,#0x0600
					LDR      R2,=0x05FA0000
					ORR      R2,R1
					STR      R2,[R0]
;PRIGROUP: 110
                    LDR      R0,=NVICISER1
					LDR      R1,[R0]
					ORR      R1,#0x20
					STR      R1,[R0]
	                BX       R14
	                ENDP
SysTickInitialize   PROC
	                EXPORT   SysTickInitialize
					LDR      R0,=STKLOAD
					LDR      R1,=0x000DBB9F
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Set SysTick reload value. RELOAD: 0x44AA1F.
					MOV      R1,#0x01
					LDRB     R2,[R0,#-0x04]  ;STKCTRL
					ORR      R2,R1
					STRB     R2,[R0,#-0x04]  ;STKCTRL
;Enable SysTick. ENABLE: 1
					MOV      R1,#0x02
					LDRB     R2,[R0,#-0x04]  ;STKCTRL
					ORR      R2,R1
					STRB     R2,[R0,#-0x04]  ;STKCTRL
;AHB/8, counting down to zero to assert the SysTick exception request.
;CLKSOURCE: 0, TICKINT: 1
                    BX       R14     
					ENDP
SystickHandler      PROC 
                    EXPORT   SystickHandler
					IMPORT   LEDControl
					PUSH     {R14}
					LDR      R0,=0x20000040
					LDR      R1,[R0]
;Load timeout status variable for the specific address.
					CMP      R1,#0x03
					ITEEE    NE
					ADDNE    R1,#0x01
					MOVEQ    R1,#0x00
					LDREQ    R2,=0x2000003C
					STREQ    R1,[R2]
					STR      R1,[R0]
;Check the value of timeout status variable, if greater than 3, reset timeout status variable & PCM data offset 
;counter variable.
					LDR      R1,=0x20000034
					LDR      R0,[R1]
;Load LED status variable for the specific address.
					CMP      R0,#0x00
;Check current LED status.
                    ITE      NE
                    MOVNE    R0,#0x00
                    MOVEQ    R0,#0xFF
                    BL       LEDControl
;Change LED status.
					STR      R0,[R1]
;Synchronize current LED status to variable.
                    POP      {R15}
;ISR return.
                    ENDP
USART1IRQHandler    PROC
	                EXPORT   USART1IRQHandler
	                IMPORT   DACStart
					PUSH     {R14}
					LDR      R0,=0x20000040
					MOV      R1,#0x00
					STR      R1,[R0]
;Reset timeout status variable.
	                LDR      R0,=USART1DR
					LDRB     R1,[R0]
;Read USART1 received data.
					LDR      R0,=0x2000003C
					LDR      R2,[R0]
;Load PCM data offset counter value.
                    LDR      R3,=0x20000038
;Load PCM data base address.
                    STRB     R1,[R3,R2]
;Write received data.
                    CMP      R2,#0x03
                    ITEE     NE
                    ADDNE    R2,#0x01
					MOVEQ    R2,#0x00
					BLEQ     DACStart
					STR      R2,[R0]
;Reset PCM data offset counter value.
                    POP      {R15}
;ISR return.
                    ENDP	
	                ALIGN
					END