StackSize           EQU        0x00000100
	AREA    STACK,NOINIT,READWRITE,ALIGN=3
StackMen            SPACE    StackSize
_initial_sp

HeapSize            EQU        0X00000100
	AREA    HEAP,NOINIT,READWRITE,ALIGN=3
_heap_base
HeapMen             SPACE    HeapSize
_heap_limit

                    PRESERVE8
					THUMB
;Vector Table Mapped to Address 0 at Reset
	AREA    RESET,CODE,READONLY
		            EXPORT   Vectors
Vectors
                    DCD      _initial_sp             
					DCD      Reset_Handler          
					DCD      NMIHandler          
					DCD      HardFaultHandler   
					DCD      MemManageHandler  
					DCD      BusFaultHandler 
					DCD      UsageFaultHandler 
					DCD      0
					DCD      0
					DCD      0
					DCD      0
					DCD      SVCALL
					DCD      DebugMonitor
					DCD      0
					DCD      PendSV
					DCD      SystickHandler
					DCD      WWDGIRQHandler
					DCD      PVDIRQHandler
					DCD      TAMPERIRQHandler
					DCD      RTCIRQHandler
					DCD      FLASHIRQHandler
					DCD      RCCIRQHandler
					DCD      EXTI0IRQHandler
					DCD      EXTI1IRQHandler
					DCD      EXTI2IRQHandler
					DCD      EXTI3IRQHandler
					DCD      EXTI4IRQHandler
					DCD      DMA1Channel1IRQHandler
					DCD      DMA1Channel2IRQHandler
					DCD      DMA1Channel3IRQHandler
					DCD      DMA1Channel4IRQHandler
					DCD      DMA1Channel5IRQHandler
					DCD      DMA1Channel6IRQHandler
					DCD      DMA1Channel7IRQHandler
					DCD      ADCIRQHandler
					DCD      USBHPCANTXIRQHandler
					DCD      USBLPCANRX0IRQHandler
					DCD      CANRX1IRQHandler
					DCD      CANSCEIRQHandler
					DCD      EXTI95IRQHandler
					DCD      TIM1BRKIRQHandler
					DCD      TIM1UPIRQHandler
					DCD      TIM1TRGCOMIRQHandler
					DCD      TIM1CCIRQHandler
					DCD      TIM2IRQHandler
					DCD      TIM3IRQHandler
					DCD      TIM4IRQHandler
					DCD      I2C1EVIRQHandler
					DCD      I2C1ERIRQHandler
					DCD      I2C2EVIRQHandler
					DCD      I2C2ERIRQHandler
					DCD      SPI1IRQHandler
					DCD      SPI2IRQHandler
					DCD      USART1IRQHandler
					DCD      USART2IRQHandler
					DCD      USART3IRQHandler
					DCD      EXTI1510IRQHandler
					DCD      RTCAlarmIRQHandler
					DCD      USBWakeUpIRQHandler
					DCD      TIM8BRKIRQHandler
					DCD      TIM8UPIRQHandler
					DCD	     TIM8TRGCOMIRQHandler
					DCD      TIM8CCIRQHandler
					DCD      ADC3IRQHandler
					DCD      FSMCIRQHandler
					DCD      SDIOIRQHandler
					DCD      TIM5IRQHandler
					DCD      SPI3IRQHandler
					DCD      UART4IRQHandler
					DCD      UART5IRQHandler
					DCD      TIM6IRQHandler
					DCD      TIM7IRQHandler
					DCD      DMA2Channel1IRQHandler
					DCD      DMA2Channel2IRQHandler
					DCD      DMA2Channel3IRQHandler
					DCD      DMA2Channel45IRQHandler
					
EndVectors
VectorsSize         EQU      EndVectors - Vectors

	AREA    |.text| ,CODE,READONLY
Reset_Handler        PROC 
                    EXPORT   Reset_Handler           [WEAK]
					IMPORT   __main
					LDR      R0,=__main
					BX       R0
					ENDP
;Dummy Exception Handlers (infinite loops which can be modified)
NMIHandler          PROC     
	                EXPORT   NMIHandler             [WEAK]
					B    .
					ENDP
HardFaultHandler    PROC     
                    EXPORT   HardFaultHandler       [WEAK]
                    B    .
                    ENDP
MemManageHandler  	PROC  
                    EXPORT   MemManageHandler       [WEAK]
                    B    .
                    ENDP				
BusFaultHandler     PROC 
                    EXPORT   BusFaultHandler        [WEAK]
                    B    .
                    ENDP
UsageFaultHandler   PROC 
                    EXPORT   UsageFaultHandler      [WEAK]
                    B    .
                    ENDP
SVCALL              PROC 
                    EXPORT   SVCALL                 [WEAK]
                    B    .
                    ENDP
DebugMonitor        PROC 
                    EXPORT   DebugMonitor           [WEAK]
                    B    .
                    ENDP
PendSV              PROC 
                    EXPORT   PendSV                 [WEAK]
                    B    .
                    ENDP
SystickHandler      PROC 
                    EXPORT   SystickHandler         [WEAK]
                    B    .
                    ENDP
;External interrupts
Default_Handler     PROC 
                    EXPORT   WWDGIRQHandler          [WEAK]
                    EXPORT   PVDIRQHandler           [WEAK]
                    EXPORT   TAMPERIRQHandler        [WEAK]
                    EXPORT   RTCIRQHandler           [WEAK]
                    EXPORT   FLASHIRQHandler         [WEAK]
	                EXPORT   RCCIRQHandler           [WEAK]
	                EXPORT   EXTI0IRQHandler         [WEAK]
	                EXPORT   EXTI1IRQHandler         [WEAK]
	                EXPORT   EXTI2IRQHandler         [WEAK]
	                EXPORT   EXTI3IRQHandler         [WEAK]
	                EXPORT   EXTI4IRQHandler         [WEAK]
	                EXPORT   DMA1Channel1IRQHandler  [WEAK]
	                EXPORT   DMA1Channel2IRQHandler  [WEAK]
	                EXPORT   DMA1Channel3IRQHandler  [WEAK]
	                EXPORT   DMA1Channel4IRQHandler  [WEAK]
	                EXPORT   DMA1Channel5IRQHandler  [WEAK]
	                EXPORT   DMA1Channel6IRQHandler  [WEAK]
	                EXPORT   DMA1Channel7IRQHandler  [WEAK]
	                EXPORT   ADCIRQHandler           [WEAK]
	                EXPORT   USBHPCANTXIRQHandler    [WEAK]
	                EXPORT   USBLPCANRX0IRQHandler   [WEAK]
	                EXPORT   CANRX1IRQHandler        [WEAK]
                    EXPORT   CANSCEIRQHandler        [WEAK]
					EXPORT   EXTI95IRQHandler        [WEAK]
					EXPORT   TIM1BRKIRQHandler       [WEAK]
					EXPORT   TIM1UPIRQHandler        [WEAK]
					EXPORT   TIM1TRGCOMIRQHandler    [WEAK]
					EXPORT   TIM1CCIRQHandler        [WEAK]
					EXPORT   TIM2IRQHandler          [WEAK]
					EXPORT   TIM3IRQHandler          [WEAK]
					EXPORT   TIM4IRQHandler          [WEAK]
					EXPORT   I2C1EVIRQHandler        [WEAK]
					EXPORT   I2C1ERIRQHandler        [WEAK]
					EXPORT   I2C2EVIRQHandler        [WEAK]
					EXPORT   I2C2ERIRQHandler        [WEAK]
					EXPORT   SPI1IRQHandler          [WEAK]
					EXPORT   SPI2IRQHandler          [WEAK]
					EXPORT   USART1IRQHandler        [WEAK]
					EXPORT   USART2IRQHandler        [WEAK]
					EXPORT   USART3IRQHandler        [WEAK]
					EXPORT   EXTI1510IRQHandler      [WEAK]
					EXPORT   RTCAlarmIRQHandler      [WEAK]
					EXPORT   USBWakeUpIRQHandler     [WEAK]
					EXPORT   TIM8BRKIRQHandler       [WEAK]
					EXPORT   TIM8UPIRQHandler        [WEAK]
					EXPORT   TIM8TRGCOMIRQHandler    [WEAK]
					EXPORT   TIM8CCIRQHandler        [WEAK]
					EXPORT   ADC3IRQHandler          [WEAK]
					EXPORT 	 FSMCIRQHandler          [WEAK]
					EXPORT   SDIOIRQHandler          [WEAK]
					EXPORT   TIM5IRQHandler          [WEAK]
					EXPORT   SPI3IRQHandler          [WEAK]
					EXPORT   UART4IRQHandler         [WEAK]
					EXPORT   UART5IRQHandler         [WEAK]
					EXPORT   TIM6IRQHandler          [WEAK]
					EXPORT   TIM7IRQHandler          [WEAK]
					EXPORT 	 DMA2Channel1IRQHandler  [WEAK]
					EXPORT   DMA2Channel2IRQHandler  [WEAK]
					EXPORT   DMA2Channel3IRQHandler  [WEAK]
					EXPORT   DMA2Channel45IRQHandler [WEAK]
WWDGIRQHandler
PVDIRQHandler
TAMPERIRQHandler
RTCIRQHandler
FLASHIRQHandler
RCCIRQHandler
EXTI0IRQHandler
EXTI1IRQHandler
EXTI2IRQHandler
EXTI3IRQHandler
EXTI4IRQHandler
DMA1Channel1IRQHandler
DMA1Channel2IRQHandler
DMA1Channel3IRQHandler
DMA1Channel4IRQHandler
DMA1Channel5IRQHandler
DMA1Channel6IRQHandler
DMA1Channel7IRQHandler
ADCIRQHandler
USBHPCANTXIRQHandler
USBLPCANRX0IRQHandler
CANRX1IRQHandler
CANSCEIRQHandler
EXTI95IRQHandler
TIM1BRKIRQHandler
TIM1UPIRQHandler
TIM1TRGCOMIRQHandler
TIM1CCIRQHandler
TIM2IRQHandler
TIM3IRQHandler
TIM4IRQHandler
I2C1EVIRQHandler
I2C1ERIRQHandler
I2C2EVIRQHandler
I2C2ERIRQHandler
SPI1IRQHandler
SPI2IRQHandler
USART1IRQHandler
USART2IRQHandler
USART3IRQHandler
EXTI1510IRQHandler
RTCAlarmIRQHandler
USBWakeUpIRQHandler
TIM8BRKIRQHandler
TIM8UPIRQHandler
TIM8TRGCOMIRQHandler
TIM8CCIRQHandler
ADC3IRQHandler
FSMCIRQHandler
SDIOIRQHandler
TIM5IRQHandler
SPI3IRQHandler
UART4IRQHandler
UART5IRQHandler
TIM6IRQHandler
TIM7IRQHandler
DMA2Channel1IRQHandler
DMA2Channel2IRQHandler
DMA2Channel3IRQHandler
DMA2Channel45IRQHandler
					B    .
					ENDP
                    ALIGN						
					IF       :DEF:__MICROLIB
					EXPORT   _initial_sp
					EXPORT   _heap_base
					EXPORT   _heap_limit
					ELSE
					;IMPORT   __use_two_region_memor
					EXPORT   __user_initial_stackheap
__user_initial_stackheap 
                    LDR      R0,=HeapMen
                    LDR      R1,=(StackMen+StackSize)
					LDR      R2,=(HeapMen+HeapSize)
					LDR      R3,=StackMen
					BX       LR
					ALIGN
					ENDIF
					END