                    INCLUDE  Map.s
					
	AREA    USARTPROC,CODE,READONLY
		
USART1Initialize	PROC
	                EXPORT   USART1Initialize
					PUSH     {R14}
					LDR      R0,=GPIOACRH
					LDR      R1,[R0]
					LDR      R2,=0xFFFFFF0F
					AND      R1,R2
                    ORR      R1,#0x90
					STR      R1,[R0]
;Alternate function output Push-pull, output mode, max speed 10 MHz.
;CNF9: 10, MODE: 10.
                    LDR      R0,=USART1CR1
					MOVW     R1,#0x2000
					STR      R1,[R0]
;USART enable. UE: 1
					;MOV      R1,#0x26  ;Baud rate: 1920000Kbps HCLK: 72MHz
					MOV      R1,#0x3B  ;Baud rate: 1920000Kbps HCLK: 112.896MHz
					;MOV     R1,#0x3F  ;Baud rate: 1920000Kbps HCLK: 120MHz
					STR      R1,[R0,#-0x04]  ;USART1BRR
;Baud rate: 1920000Kbps. DIVMantissa: 000000000010, DIVFraction: 0110.
					LDR      R2,[R0]
					MOV      R1,#0x20
					ORR      R2,R1
					STR      R2,[R0]
 ;A USART interrupt is generated whenever ORE=1 or RXNE=1 in the USART_SR register.
 ;RXNEIE: 1.
					MOV      R1,#0x0C
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Transmitter is enable, Receiver is enabled and begins searching for a start bit.
;TE: 1, RE: 1.
					MOV      R0,#0x00
					BL       USART1SendByte 
					BL       USART1SendByte
					BL       USART1SendByte
					BL       USART1SendByte
;Send some empty bytes through USART1
                    POP      {R15}
	                ENDP
USART1SendByte      PROC
	                EXPORT   USART1SendByte
	                PUSH     {R1-R2}
					LDR      R1,=USART1SR
CheckTXE    		LDR      R2,[R1]
                    AND      R2,#0x80
					CMP      R2,#0x80
					BNE      CheckTXE
;Check if transmit data register is empty, if not, recheck.
					STR      R0,[R1,#0x04]  ;USART1DR
;Write data to transmisson data register.
					POP      {R1-R2}
					BX       R14
	                ENDP
ShowStartMessage    PROC
	                EXPORT   ShowStartMessage
					PUSH     {R14}
	                LDR      R1,=0x20000000
;Get RAM Base address of the string.
					MOV      R3,#0x32
;MAX offset address of "StartMessage".
					MOV      R2,#0x00
;Offset counter. Reset to 0.
SendSTAMES    		LDRB     R0,[R1,R2]
                    BL       USART1SendByte
					CMP      R3,R2
					ITET     NE
					ADDNE    R2,#0x01
					POPEQ    {R14}
					BNE      SendSTAMES
	                BX       R14
	                ENDP
					ALIGN
					END